#include <bits/stdc++.h>

using namespace std;

const int kMod = 666013;

namespace ModOps {
    int add(int a, int b) {
        a += b;
        if(a >= kMod) a -= kMod;
        return a;
    }
    int sub(int a, int b) {
        a -= b;
        if(a < 0) a += kMod;
        return a;
    }
    int mul(int a, int b) {
        return 1LL * a * b % kMod;
    }
    int lgpow(int b, int e) {
        int r = 1;
        while(e) {
            if(e % 2) 
                r = mul(r, b);
            b = mul(b, b);
            e /= 2;
        }
        return r;
    }
    int inv(int x) {
        return lgpow(x, kMod - 2);
    }

    vector<int> Fact, IFact;
    bool __processed;

    void ProcessFactorials(int maxx) {
        ++maxx;
        Fact.resize(maxx);
        IFact.resize(maxx);

        Fact[0] = IFact[0] = 1;
        for (int i = 1; i <= maxx; ++i)
            Fact[i] = mul(Fact[i - 1], i);

        IFact[maxx] = inv(Fact[maxx]);
        for(int i = maxx - 1; i >= 1; --i)
            IFact[i] = mul(i + 1, IFact[i + 1]);

        __processed = true;
    }

    int GetComb(int n, int k) {
        assert(__processed);
        return mul(mul(Fact[n], IFact[n - k]), IFact[k]);
    }
};
using namespace ModOps;

struct Rect {
    int l, u, r, d;

    void Translate(int dx, int dy) {
        l += dx; r += dx;
        u += dy; d += dy;
    }
    void Flip() {
        swap(l, u);
        swap(r, d);
    }
    void Dump() {
        cerr << "Rect: " << l << " " << u << " " << r << " " << d << endl;
    }
};

int GetSmall(int i, int j) {
    return GetComb(i + j + 2, j + 1);
}
int GetMedium(Rect R) {
    int ans = 0;
    ans = add(ans, GetSmall(R.d, R.r));
    ans = sub(ans, GetSmall(R.u - 1, R.r));
    ans = sub(ans, GetSmall(R.d, R.l - 1));
    ans = add(ans, GetSmall(R.u - 1, R.l - 1));
    return ans;
}
int GetMediumStar(int x, int y, Rect R) {
    // cerr << x << " " << y << endl;
    // R.Dump();

    assert(R.l <= R.r);
    assert(R.u <= R.d);

    R.Translate(-x, -y);

    assert(1LL * R.l * R.r >= 0);
    assert(1LL * R.u * R.d >= 0);

    if (R.l < 0) {R.l *= -1; R.r *= -1; swap(R.l, R.r);}
    if (R.u < 0) {R.u *= -1; R.d *= -1; swap(R.u, R.d);} 

    auto ret = GetMedium(R);
    // cerr << "> " << ret << endl;
    return ret;
}

int Solve(Rect A, Rect B) {
    int x = A.r;

    int ans = 0;
    for (int y = min(A.u, B.u); y <= max(A.d, B.d); ++y) {
        // cerr << "y: " << y << endl;
        int ld = y > A.u ? GetMediumStar(x, y, Rect{A.l, A.u, A.r, min(y - 1, A.d)}) : 0;
        int ln = y >= A.u && y <= A.d ? GetMediumStar(x, y, Rect{A.l, y, A.r, y}) : 0;
        int lu = y < A.d ? GetMediumStar(x, y, Rect{A.l, max(y + 1, A.u), A.r, A.d}) : 0;

        int rd = y > B.u ? GetMediumStar(x + 1, y, Rect{B.l, B.u, B.r, min(y - 1, B.d)}) : 0;
        int rn = y >= B.u && y <= B.d ? GetMediumStar(x + 1, y, Rect{B.l, y, B.r, y}) : 0;
        int ru = y < B.d ? GetMediumStar(x + 1, y, Rect{B.l, max(y + 1, B.u), B.r, B.d}) : 0;

        int old = ans;
        ans = add(ans, mul(ld, ru));
        ans = add(ans, mul(ld, rn));
        ans = add(ans, mul(lu, rd));
        ans = add(ans, mul(lu, rn));
        ans = add(ans, mul(ln, ru));
        ans = add(ans, mul(ln, rd));
        ans = add(ans, mul(ln, rn));
        // cerr << "delta: " << sub(ans, old) << endl;
    }

    return ans;
}

int main() {
    Rect A, B;
    cin >> A.l >> A.u >> A.r >> A.d >> B.l >> B.u >> B.r >> B.d;

    ProcessFactorials(400000);


    int ret, tries;
    for (int tries = 0; tries < 2; ++tries) {

        if (A.r < B.l) {ret = Solve(A, B); break;}
        else if (B.r < A.l) {ret = Solve(B, A); break;}
        
        A.Flip(); B.Flip();
    }

    assert(tries < 2);
    cout << ret << endl;


    return 0;
}