#include <cassert>

#include <algorithm>
#include <fstream>
#include <iostream>
#include <vector>
using namespace std;

const int kMaxN = 1e5+5;

vector<bool> is_edge_visited;
int next_color = 1;

struct Edge {
    int a, b, color, id;
    bool is_virtual;

    int Other(int node) {
        return a + b - node;
    }

    bool IsVisited() {
        return is_edge_visited[id];
    }

    void Visit() {
        assert(IsVisited() == false);
        is_edge_visited[id] = true;
    }
};

vector<Edge> all_edges;
vector<int> edges[kMaxN];

int AddEdge(int a, int b, bool is_virtual = false) {
    int id = all_edges.size();
    all_edges.push_back(Edge({a, b, 0, (int)all_edges.size(), is_virtual}));
    edges[a].push_back(id);
    edges[b].push_back(id);
    is_edge_visited.push_back(false);
    return id;
}

int edges_itr[kMaxN];
int oth;
void EulerianCycle(int node) {
    vector<pair<int, int>> stack = {{node, -1}};

    while (stack.size()) {
        int node = stack.back().first;
        int father_edge = stack.back().second;
        while (edges_itr[node] < (int)edges[node].size()) {
            {
                auto& edge = all_edges[edges[node][edges_itr[node]]];
                edges_itr[node] += 1;
                if (edge.IsVisited()) {
                    continue;
                }

                edge.Visit();
                oth = edge.Other(node);
            }

            stack.push_back({oth,edges[node][edges_itr[node] - 1]});
            goto next_euler_cicle;
//            EulerianCycle(oth);
        }

        stack.pop_back();
        if (father_edge != -1 and all_edges[father_edge].is_virtual == false) {
            all_edges[father_edge].color = next_color++;
        }
    
next_euler_cicle:;

    }
}

int main() {
    ifstream cin("nogcd.in");
    ofstream cout("nogcd.out");
    int n, m; cin >> n >> m;
    for (int i = 0; i < m; i += 1) {
        int a, b; cin >> a >> b;
        AddEdge(a, b);
    }

    vector<int> odd_nodes;
    for (int i = 1; i <= n; i += 1) {
        if (edges[i].size() % 2) {
            odd_nodes.push_back(i);
        }
    }

    for (int i = 0; i < (int)odd_nodes.size(); i += 2) {
        AddEdge(odd_nodes[i], odd_nodes[i + 1], true);
    }

    EulerianCycle(1);

    for (auto itr : all_edges) {
        if (itr.is_virtual) {
            continue;
        }

        cout << itr.a << ' ' << itr.b << ' ' << itr.color << '\n';
    }

    return 0;
}
